/*****************************************************************************/
/* A bus type and instance for usbback_devices. This bus matches the         */
/* usbback_devices with the usbback_driver.                                  */
/*                                                                           */
/* Copyright (c) 2005 Harry Butterworth IBM Corporation                      */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General */
/* Public License for more details.                                          */
/*                                                                           */
/* You should have received a copy of the GNU General Public License along   */
/* with this program; if not, write to the Free Software Foundation, Inc.,   */
/* 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                   */
/*                                                                           */
/*****************************************************************************/

#include "usbback_bus.h"
#include "usbback_trace.h"

static int usbback_bus_match
  ( struct device * dev, struct device_driver * drv )
{
    trace();

    return 1;
}

struct bus_type usbback_bus_type =
{
    .name  = "usbback",
    .match = usbback_bus_match,
};

static void usbback_bus_release( struct device * dev )
{
    trace();
}

struct device usbback_bus =
{
    .bus_id  = "usbback",
    .release = usbback_bus_release,
};

static int usbback_bus_init_or_exit( int exit )
{
    trace();

    int return_value = 0;

    if( exit )
    {
        goto EXIT;
    }

    if( ( return_value = bus_register( &usbback_bus_type ) ) != 0 )
    {
        goto EXIT_NO_BUS_REGISTER;
    }

    if( ( return_value = device_register( &usbback_bus ) ) != 0 )
    {
        goto EXIT_NO_DEVICE_REGISTER;
    }

    trace0( "success" );

    return 0;

  EXIT:

    device_unregister( &usbback_bus );

  EXIT_NO_DEVICE_REGISTER:

    bus_unregister( &usbback_bus_type );

  EXIT_NO_BUS_REGISTER:

    return return_value;
}

int usbback_bus_init( void )
{
    trace();

    return usbback_bus_init_or_exit( 0 );
}

void usbback_bus_exit( void )
{
    trace();

    (void)usbback_bus_init_or_exit( 1 );
}
