/*****************************************************************************/
/* usbback_driver_backend is the representation in the driver of the         */
/* back-end side of a single front-end to back-end connection.               */
/* One of these objects is used by the usbback_driver to manage each         */
/* usbback_device.                                                           */
/*                                                                           */
/* Copyright (c) 2005 Harry Butterworth IBM Corporation                      */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General */
/* Public License for more details.                                          */
/*                                                                           */
/* You should have received a copy of the GNU General Public License along   */
/* with this program; if not, write to the Free Software Foundation, Inc.,   */
/* 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                   */
/*                                                                           */
/*****************************************************************************/

#ifndef USBBACK_DRIVER_BACKEND_H
#define USBBACK_DRIVER_BACKEND_H

#include "usbback_device.h"

struct usbback_driver_backend;

extern struct usbback_driver_backend * usbback_driver_backend_allocate
  ( struct usbback_device * device );

extern void usbback_driver_backend_shutdown
  ( struct usbback_driver_backend * backend );

extern domid_t usbback_driver_backend_query_remote_domain_id
  ( struct usbback_driver_backend * backend );

#endif
