/*****************************************************************************/
/* Simple trace macros                                                       */
/* Copyright (c) 2005 Harry Butterworth IBM Corporation                      */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General */
/* Public License for more details.                                          */
/*                                                                           */
/* You should have received a copy of the GNU General Public License along   */
/* with this program; if not, write to the Free Software Foundation, Inc.,   */
/* 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA                   */
/*                                                                           */
/*****************************************************************************/

#ifndef USBBACK_TRACE_H
#define USBBACK_TRACE_H

#include <linux/config.h>
#include <linux/kernel.h>

#ifdef CONFIG_XEN_USBDEV_BACKEND_TRACE

#define trace0( format ) \
printk( KERN_INFO "usbback %s:" format "\n", __PRETTY_FUNCTION__ )

#define trace1( format, a0 ) \
printk( KERN_INFO "usbback %s:" format "\n", __PRETTY_FUNCTION__, a0 )

#define trace2( format, a0, a1 ) \
printk( KERN_INFO "usbback %s:" format "\n", __PRETTY_FUNCTION__, a0, a1 )

#define trace3( format, a0, a1, a2 ) \
printk( KERN_INFO "usbback %s:" format "\n", __PRETTY_FUNCTION__, a0, a1, a2 )

#define trace() trace0( "" )

#else

#define trace0( format )
#define trace1( format,a0 )
#define trace2( format,a0, a1 )
#define trace3( format,a0, a1, a2 )
#define trace()

#endif

#endif
